* _SprDraw: this calls the QL sprite picture driver.
* after trying to centre the sprite in the item
* v. 1.01 	1996 Nov 08 21:23:33
*
* copyright (c) w. lenerz 1996
*

	section	text

	xdef	_SprDraw		; use underscore so that 'c' finds it

	xref	_LinkPROforma	; does proforma link

	xref	_PFPictureCount	; returns n of picture drivers
	xref	_PFPicturenext	; get next picture driver
	xref	_PFPictureDisplay	; calls picture driver to draw picture
	xref	_PFMoveTo 	; moves to given coordinates
	xref	_xpix2PF		; x- pixel to point conversion
	xref	_ypix2PF		; y - pixel to point conversion
	xref	_PFPageOriginSet	; set origin of pagebox
	xref	_PFPageBboxGet	; get data about pagebox
	xref	_PF2xpix
	xref	_PF2ypix

; on the stack we find:
;  4(A7)	gstate
;  8(A7)	address of sprite

*
; from 'C', call this as follows:
; Error SprDraw(Gstate gstate, char *sprite);
*


os	equ	14*4		 ; number of regs saved on stack...

myregs	REG	A0-A6/D1-D7	; keep all regs used

_SprDraw	MOVEM.L	myregs,-(A7)
	MOVE.L	os+4(A7),A5	; this is the gstate
	MOVE.L	os+8(A7),D0	; pointer to sprite
	BEQ	spout		; no sprite - no joy ->...
;;
	ADD.L	#60,D0		; point past header
;;
	MOVE.L	D0,A6		; A6= pointer to sprite
	MOVEQ	#100,D1
	MOVEQ	#-1,D2
	MOVEQ	#$18,D0
	TRAP	#1		; get some mem
	TST.L	D0		; ok?
	BNE	spout		; no->...
	MOVE.L	A0,A4		; A4 =  my memory space

; first of all, find the driver ID for the sprite picture driver

; for that, get the number of drivers

	MOVE.L	A4,-(A7)		; place for driver count
	MOVE.L	A5,-(A7)
	JSR	_PFPictureCount	; get nbr of picture drivers
	ADDQ.L	#8,A7

; now get the name of each driver in turn, see whether it is mine
	MOVE.L	(A4),D7		; counter
	BEQ	spout		; no driver? no joy! ->...
	MOVE.L	A4,D6
	ADDQ.L	#4,D6		; pointer to place for string
	LEA	drv_name,A0
	MOVE.L	A0,D5		; pointer to my driver name
	MOVE.L	D6,-(A7)		; where to put the driver name string
	MOVE.L	A4,-(A7)		; where to put the driver ID
	MOVE.L	A5,-(A7)		; gstate
	SUBQ.W	#1,D7		; prepare for dbf
loop	JSR	_PFPicturenext	; get next picture driver
	TST.L	D0		; ok ?
	BNE.S	no_more		; no->...
	MOVE.L	D6,A1		; point to driver name string
	MOVE.L	D5,A0		; name of my driver
	MOVE.W	(A0)+,D0		; length of my driver's name
	SUBQ.W	#1,D0		; do comparison loop now
tnameloop CMP.B	(A1)+,(A0)+	; is it name of my driver?
	BNE.S	do_gloop		; no, so try next driver ->...
	DBF	D0,tnameloop
	BRA.S	drv_found 	; if we get here, name was the same->..
do_gloop	DBF	D7,loop		; try until no more drivers
no_more	LEA	12(A7),A7 	; if we get here: my driver was not...
	BRA	spout		; ...found, so leave ->...

; here, I found my picture driver
drv_found LEA	12(A7),A7
	MOVE.L	(A4),D7		; D7 = my driverID

; now a vague attempt to centre the item by setting the origin to where drawing
; will start
; first set the drawing origin to 0,0
	MOVE.L	A4,-(A7)		; place for result
	MOVE.L	A5,-(A7)
	JSR	_PFPageBboxGet	; get info about box: this leaves the
	ADDQ.L	#8,A7		; following info at (A4):
				; 0  xsiz        }
				; 4  ysiz         }
				; 8  xorig        } >>> of box, in Pt
				; 12 y orig      }
				; 16 page x orig
				; 20 page y orig	(also in pt)

	MOVE.L	20(A4),D0 	; page y origin
	NEG.L	D0
	MOVE.L	D0,-(A7)		; move back by that much
	MOVE.L	16(A4),D0 	; page x orgin
	NEG.L	D0
	MOVE.L	D0,-(A7)		; same : as a result, we will be at 0,0
	MOVE.L	A5,-(A7)
	JSR	_PFPageOriginSet	; set origin to 0,0
	LEA	12(A7),A7 	; reset stack

; now see how often the sprite would fit in the window, to make it larger
; if need be

	MOVEQ	#0,D1		; make sure this is 0
	MOVE.L	(A4),-(A7)	; box xsiz in pt
	JSR	_PF2xpix		; make into pixels now
	ADDQ.L	#4,A7
	MOVE.W	4(A6),D1		; sprites xsize in pixels
	BEQ	spout		; no x size?->...
	DIVS	D1,D0		; this is how often it fits
	MOVE.W	D0,D6
	BEQ	spout		; sprite doesn't fit in window!->...

	MOVE.L	4(A4),-(A7)	; box ysize in pt
	JSR	_PF2ypix		; make into pixels now
	ADDQ.L	#4,A7
	MOVE.W	6(A6),D1		; D1 = sprites y size in pixels
	BEQ.S	spout		; what, no y size?->...
	DIVS	D1,D0		; how often sprite fits in height
	TST.W	D0
	BEQ.S	spout		; sprite doesn't fit in window!->...


	CMP.W	D6,D0		; test which one is bigger and...
	BGE.S	no_xch		; use smaller one...
	MOVE.W	D0,D6		; this is the correct ratio
no_xch	MOVEQ	#0,D0


	MOVE.W	6(A6),D0		; sprite y size in pix
	MULU	D6,D0		; * multiplier
	MOVE.W	D0,-(A7)
	JSR	_ypix2PF		; transform pix to pt, result in D0
	ADDQ.L	#2,A7
	MOVE.L	D0,D4		; D4 = sprite ysize in pt
	MOVE.W	4(A4),D1		; get only integer part of Ysize
	SWAP	D0		; integer part of pagebox ysize
	SUB.W	D0,D1		; - sprite Ysize
	BLT.S	spout		; oops; loose item is too small!->...
	LSR.W	#1,D1		; / 2: this should be the y origin
	SWAP	D1
	MOVE.L	D1,-(A7)		; onto stack for later
	MOVEQ	#0,D0
	MOVE.W	4(A6),D0
	MULU	D6,D0
	MOVE.W	D0,-(A7)		; now do the same with the xsize
	JSR	_xpix2PF
	ADDQ.L	#2,A7
	MOVE.L	D0,D5		; D5 = sprite x size
	SWAP	D0
	MOVEQ	#0,D1
	MOVE.W	(A4),D1		; get only integer part of Xsize
	SUB.W	D0,D1		; - sprite Xsize
	BLT.S	spout2		; oops; loose item is too small!->...
	LSR.W	#1,D1		; / 2
	SWAP	D1
	MOVE.L	D1,-(A7)		; xorigin
	MOVE.L	A5,-(A7)		; gstate
	JSR	_PFMoveTo 	; this is where drawing will start
	LEA	12(A7),A7

	MOVEQ	#$19,D0
	MOVE.L	A4,A0
	TRAP	#1		; release the memory now

; "draw" the sprite by calling the picture driver
	MOVE.L	D4,-(A7)		; sprite ysize in pt
	MOVE.L	D5,-(A7)		; spriye xsize in pt
;;
	SUB.L	#60,A6
;;
	MOVE.L	A6,-(A7)		; sprite
	MOVE.L	D7,-(A7)		; driver id
	MOVE.L	A5,-(A7)		; gstate
	JSR	_PFPictureDisplay	; show picture (call my driver)
	LEA	20(A7),A7 	; readjust stack
spout	MOVEM.L	(A7)+,myregs
	MOVEQ	#0,D0		; always return with ok (!)
	RTS
spout2	ADDQ.L	#4,A7
	BRA.S	spout

; name of this device driver
drv_name	dc.w	dcn2-*-2
dcn1	dc.b	'QL Mode 4 Sprite Picture driver'
dcn2
	dc.w	_LinkPROforma-*	; make sure there is a link to proforma

	
	end
