/*
	ProWesS, PROGS Windowing System

	PWWindowMove

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 8 February 1995
*/

#include <win.h>

#include "private.h"
#include "PWHandler.h"

extern short  system_xshadow;
extern short  system_yshadow;
extern short  system_borderwidth;
extern short  system_scaleborderwidth;
extern char   system_previewmove;
extern short  system_previewtimeout;

Error PWWindowMove(PWSystem *system, short move)
{
	Error err=ERR_NC;
	int xpos=system->ptr_xpos;
	int ypos=system->ptr_ypos;
	int win_xpos=system->win_xpos;
	int win_ypos=system->win_ypos;
	TimeOut timeout=FOREVER;
	pix lx,ly;
	WindowInfo wi;

	if (system_previewmove) timeout=system_previewtimeout;

	while (err==ERR_NC)
	{
		lx=system->ptr_xpos;
		ly=system->ptr_ypos;

		err=WINPointerRead(system->window, timeout, EVENT_WINDOW_MOVE,
						   &system->ptr_xpos,&system->ptr_ypos,&system->ptr_info);

		if (err==ERR_NC && lx==system->ptr_xpos && ly==system->ptr_ypos)
			continue;

		/* calculate new origin of window */
		system->win_xpos=win_xpos+system->ptr_xpos-xpos;
		system->win_ypos=win_ypos+system->ptr_ypos-ypos;

		/* determine position for window */
		PWDeterminePosition(system);

		/* actually move window */
		WINMove(system->window, system->win_xpos, system->win_ypos);
		PWSetSprites(system);
	}

	/* now do possible move in PROforma */
	err=PFPWindowMove(system->gstate,system->win_xpos-win_xpos,
									 system->win_ypos-win_ypos);

	return err;
}
