/*
	ProWesS, PROGS Windowing System

	PWWindowScale

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 13 February 1995
*/

#include <win.h>

#include "private.h"
#include "PWHandler.h"

extern char  system_previewscale;
extern short system_previewtimeout;

Error PWWindowScale(PWSystem *system, short scale)
{
	Error err=ERR_NC;
	pix xpos=system->ptr_xpos;
	pix ypos=system->ptr_ypos;
	pix win_xpos=system->win_xpos;
	pix win_ypos=system->win_ypos;
	pix win_xsiz=system->curr_xsiz;
	pix win_ysiz=system->curr_ysiz;
	TimeOut timeout=FOREVER;
	pix lx,ly;
	int temp;

	if (system_previewscale) timeout=system_previewtimeout;

	while (err==ERR_NC)
	{
		lx=system->ptr_xpos;
		ly=system->ptr_ypos;

		err=WINPointerRead(system->window, timeout, EVENT_WINDOW_SIZE,
						   &system->ptr_xpos,&system->ptr_ypos,&system->ptr_info);

		if (err==ERR_NC && lx==system->ptr_xpos && ly==system->ptr_ypos)
			continue;

		/* calculate new origin and size of window */
		temp=system->ptr_xpos-xpos;
		if (scale==PW_CORNER_TOPLEFT || scale==PW_CORNER_BOTLEFT)
		{
			system->win_xpos=win_xpos+system->ptr_xpos-xpos;
			system->curr_xsiz=win_xsiz-temp;
		}
		else
			system->curr_xsiz=win_xsiz+temp;
		temp=system->ptr_ypos-ypos;
		if (scale==PW_CORNER_TOPLEFT || scale==PW_CORNER_TOPRIGHT)
		{
			system->win_ypos=win_ypos+system->ptr_ypos-ypos;
			system->curr_ysiz=win_ysiz-temp;
		}
		else
			system->curr_ysiz=win_ysiz+temp;

		PWSetWindow(system);
	}

	/* make sure system is redetermined */
	system->status|=SSTATUS_WINCHANGE;

	return err;
}
