/*
	ProWesS, PROGS Windowing System

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 19 February 1995
*/

#include "sms.h"
#include "win.h"

#include "ctype.h"
#include "ProWesS.h"

Error beep(PWObject object)
{
	return SMSBeep(2000,20);
}

Error exit(PWObject object)
{
	return PWChange(object,PW_SYSTEM_BREAKDOWN,NULL);
}

Error sleep(PWObject object)
{
	return PWChange(object,PW_SYSTEM_SLEEP,NULL);
}

void init()
{
	PWObject first,second;

	PWCreate(NULL,&first,PW_TYPE_TITLE_ITEM,
				PW_TITLE_TEXT, "seventh test",
				PW_POINTER, SPRITE_ARROW,
				NULL);
	PWCreate(first,&second,PW_TYPE_CONTAINER,
				PW_POSITION_BELOW,first,
				NULL);
	PWCreate(first,NULL,PW_TYPE_LOOSE_ITEM,
				PW_LOOSE_TEXT, "sleep",
				PW_POSITION_RIGHT_OF, first,
				PW_LOOSE_ACTION_HIT, &sleep,
				NULL);
	PWCreate(first,NULL,PW_TYPE_LOOSE_ITEM,
				PW_SLEEP_OBJECT,
				PW_LOOSE_TEXT, "job asleep",
				PW_LOOSE_ACTION_DO, &exit,
				NULL);
	PWCreate(second,&first,PW_TYPE_LOOSE_ITEM,
				PW_LOOSE_TEXT, "just an item or two",
				PW_LOOSE_KEYPRESS, 'j',
				NULL);
	PWCreate(second,NULL,PW_TYPE_LOOSE_ITEM,
				PW_LOOSE_TEXT, "to test",
				NULL);
	PWCreate(second,NULL,PW_TYPE_SEPARATOR,NULL);
	PWCreate(second,NULL,PW_TYPE_LOOSE_ITEM,
				PW_LOOSE_TEXT, "quit",
				PW_LOOSE_ACTION_HIT, &exit,
				PW_LOOSE_ACTION_DO, &beep,
				PW_LOOSE_CHANGE_STATUS, FALSE,
				NULL);
	PWActivate(first);
}
