/*
	ProWesS, PROGS Windowing System

	special program to test the speed of ProWesS
	uses the window from test_three

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 18 March 1996
*/

#include "io.h"
#include "time.h"

#include "ProWesS.h"

Error exit(PWObject object)
{
	return PWChange(object,PW_SYSTEM_BREAKDOWN,NULL);
}

void init()
{
	PWObject first,second;

	PWCreate(NULL,&first,PW_TYPE_LOOSE_ITEM,
				PW_LOOSE_TEXT, "hello world",
				PW_SYSTEM_ACTION_INIT, exit,
				NULL);
	PWCreate(first,&second,PW_TYPE_LOOSE_ITEM,
				PW_LOOSE_TEXT, "right item",
				PW_POSITION_RIGHT_OF, first,
				NULL);
	PWCreate(first,&second,PW_TYPE_LOOSE_ITEM,
				PW_LOOSE_TEXT, "left item",
				PW_POSITION_LEFT_OF, first,
				NULL);
	PWCreate(first,&second,PW_TYPE_LOOSE_ITEM,
				PW_LOOSE_TEXT, "above item",
				PW_POSITION_ABOVE, first,
				NULL);
	PWCreate(first,&second,PW_TYPE_LOOSE_ITEM,
				PW_LOOSE_TEXT, "below item",
				PW_POSITION_BELOW, first,
				PW_LOOSE_STATUS,PW_STATUS_UNAVAILABLE,
				NULL);
	PWCreate(second,&first,PW_TYPE_LOOSE_ITEM,
				PW_LOOSE_TEXT, "quit",
				PW_POSITION_RIGHT_OF, second,
				PW_LOOSE_ACTION_HIT,&exit,
				NULL);

	/* make sure the font cache is filled */
	PWActivate(first);

	/* start timing */
	{
		Time before, after;
		char time[30];
		int i;

		TIMEGet(&before);
		for (i=500 ; i ; i--)
		{
			PWActivate(first);
		}
		TIMEGet(&after);
		STRFormatPut(time,"%d seconds",after-before);
		{
			Channel chid; char chr;
			IOOpen("con",OPEN_OVER,&chid);
			IOPutString(chid,time,NULL);
			IOGet(chid,&chr);
			IOClose(chid);
		}
/*		  PWCreate(first,NULL,PW_TYPE_LOOSE_ITEM,
				PW_SYSTEM_ACTION_INIT, 0,
				PW_LOOSE_TEXT, time,
				PW_POSITION_RIGHT_OF, second,
				NULL); */
		PWActivate(first);
	}

}
