/*
	ProWesS, PROGS Windowing System

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 18 July 1995
	modified 07.06.1996 to test PW_EDLINE_ACTION_TEST
*/

#include <ctype.h>
#include <ProWesS.h>

Error natural(PWObject object, EdlineInfo *info)
{
	if (isprint(info->key) && !isdigit(info->key))
		return PW_EDLINE_TEST_NOACCEPT;
	else
		return PW_EDLINE_TEST_ACCEPT;
}

Error integer(PWObject object, EdlineInfo *info)
{
	if (info->key=='+' || info->key=='-')
	{
		if (info->string[0]=='+' || info->string[0]=='-')
		{
			info->string[0]=info->key;
			return PW_EDLINE_TEST_CHANGE;
		}
		if (info->length+1<info->maxlength)
		{
			MEMCopy(info->maxlength-1,info->string,info->string+1);
			info->string[0]=info->key;
			info->cursor++;
			return PW_EDLINE_TEST_CHANGE;
		}
		return PW_EDLINE_TEST_NOACCEPT;
	}
	if (isprint(info->key) && !isdigit(info->key))
		return PW_EDLINE_TEST_NOACCEPT;
	else
		return PW_EDLINE_TEST_ACCEPT;
}

Error number(PWObject object, EdlineInfo *info)
{
	if (info->key=='+' || info->key=='-')
	{
		if (info->string[0]=='+' || info->string[0]=='-')
		{
			info->string[0]=info->key;
			return PW_EDLINE_TEST_CHANGE;
		}
		if (info->length+1<info->maxlength)
		{
			MEMCopy(info->maxlength-1,info->string,info->string+1);
			info->string[0]=info->key;
			info->cursor++;
			return PW_EDLINE_TEST_CHANGE;
		}
		return PW_EDLINE_TEST_NOACCEPT;
	}
	if (info->key=='.')
	{
		/* only accept if no decimal point yet */
		char *str;
		for (str=info->string ; *str ; str++)
			if (*str=='.') return PW_EDLINE_TEST_NOACCEPT;
		return PW_EDLINE_TEST_ACCEPT;
	}
	if (isprint(info->key) && !isdigit(info->key))
		return PW_EDLINE_TEST_NOACCEPT;
	else
		return PW_EDLINE_TEST_ACCEPT;
}

Error init()
{
	PWObject obj,it1;

	PWCreate(NULL,&obj,PW_TYPE_OUTLINE,
				PW_OUTLINE_SLEEP,
				PW_OUTLINE_QUIT,
				NULL);
	PWCreate(obj,&it1,PW_TYPE_EDLINE,
				PW_EDLINE_ACTION_TEST, natural,
				NULL);
	PWCreate(obj,&it1,PW_TYPE_EDLINE,
				PW_EDLINE_ACTION_TEST, integer,
				NULL);
	PWCreate(obj,&it1,PW_TYPE_EDLINE,
				PW_EDLINE_ACTION_TEST, PW_EDLINE_ACTION_TEST_FLOAT,
				NULL);
	return PWActivate(obj);
}
